#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Bad Penguin - Sound configuration utility
# 1.0.0 by agx@linux.it 
# @1999 by Antonio GALLO aka AGX

TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT=$TEMPDIR/tempscript.$$
trap 'rm -f $TEMPSCRIPT ; exit $USCITA' 0
USCITA=0

#Datum
FILECONFIG="/etc/sysconfig/$PROFILE/opl3.soundcard"
S_IO=""
. $FILECONFIG

while [ 0 ]; do

  dialog --title "SoundBlaster Configuration" --menu "Fill in only the necessary values. IO, IRQ and DMA are mandatory.\nTo listen MIDI files you have also to configure the OPL3 driver." 19 68 10 \
    "IO"     "I/O address .......: $S_IO" \
    " "      "-----------------------------" \
    "SAVE"   "Save the changes" \
    "REMOVE" "Remove this cards" \
    2> $TEMPSCRIPT
  REPLY=$?
  if [ $REPLY -ne 0 ]; then
    exit
  fi
  CHOICE=`cat $TEMPSCRIPT`

  case "$CHOICE" in
  
    IO)
      dialog --inputbox "I/O address of the Sound Blaster chip\n(Usually 0x388, leave blank for autodetection)" 9 60 $S_IO 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_IO=`cat $TEMPSCRIPT`
      fi
      ;;
      
    SAVE)
      > $FILECONFIG
      echo "S_IO=\"$S_IO\"" >> $FILECONFIG
      dialog --msgbox "\nLe modifiche sono state salvate." 7 40
      exit
      ;;
      
    REMOVE)
      rm -f $FILECONFIG
      dialog --msgbox "\nIl file di configurazione e' stato rimosso." 7 50
      exit
      ;;
  esac

done
