#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Bad Penguin - Sound configuration utility
# 1.0.0 by agx@linux.it 

TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT=$TEMPDIR/tempscript.$$
trap 'rm -f $TEMPSCRIPT ; exit $USCITA' 0
USCITA=0


#Datum
FILECONFIG="/etc/sysconfig/$PROFILE/soundblaster.soundcard"
S_IO="0x220"
S_IRQ="5"
S_DMA="1"
S_DMA16=""
S_MPU=""
S_MAD16="0"
S_TRIX="0"
S_PAS2="0"
S_SMG="0"
S_ACER="0"
S_MWAVE="0"
. $FILECONFIG

while [ 0 ]; do

  dialog --title "SoundBlaster Configuration" --menu "Fill in only the necessary values. IO, IRQ and DMA are mandatory.\nTo listen MIDI files you have also to configure the OPL3 driver." 19 68 10 \
    "IO"     "I/O address .......: $S_IO" \
    "IRQ"    "IRQ ...............: $S_IRQ" \
    "DMA"    "8 bit DMA channel .: $S_DMA " \
    "DMA16"  "16-bit DMA channel : $S_DMA16" \
    "MPU"    "I/O for MPU chip ..: $S_MPU" \
    " "      "-----------------------------" \
    "SAVE"   "Save the changes" \
    "REMOVE" "Remove this cards" \
    " "      "----------------------------" \
    "MAD16"  "MAD 16 support ....: $S_MAD16" \
    "TRIX"   "Audiotrix support .: $S_TRIX" \
    "PAS2"   "Pas2 support ......: $S_PAS2" \
    "SMG"    "Logitech soundman .: $S_SMG" \
    "ACER"   "Acer notebbok supp.: $S_ACER" \
    "MWAVE"  "Mwave support .....: $S_MWAVE" \
    2> $TEMPSCRIPT
  REPLY=$?
  if [ $REPLY -ne 0 ]; then
    exit
  fi
  CHOICE=`cat $TEMPSCRIPT`

  case "$CHOICE" in
  
    IO)
      dialog --inputbox "I/O address of the Sound Blaster chip (0x220,0x240,0x260,0x280)" 9 60 $S_IO 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_IO=`cat $TEMPSCRIPT`
      fi
      ;;

    IRQ)
      dialog --inputbox "IRQ of the Sound Blaster chip (5,7,9,10)" 8 60 $S_IRQ 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_IRQ=`cat $TEMPSCRIPT`
      fi
      ;;

    DMA)
      dialog --inputbox "8-bit DMA channel for the Sound Blaster (0,1,3)" 8 60 $S_DMA 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_DMA=`cat $TEMPSCRIPT`
      fi
      ;;

    DMA16)
      dialog --inputbox "16-bit DMA channel for SB16 and equivalent cards (5,6,7)" 8 60 $S_DMA16 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_DMA16=`cat $TEMPSCRIPT`
      fi
      ;;

    MPU)
      dialog --inputbox "I/O for MPU chip if present (0x300,0x330)" 8 60 $S_MPU 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_MPU=`cat $TEMPSCRIPT`
      fi
      ;;

    MAD16)
      dialog --inputbox "Set when loading this as part of the MAD16 setup only ( 1=ENABLE, 0=DISABLE )" 9 60 $S_MAD16 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_MAD16=`cat $TEMPSCRIPT`
      fi
      ;;

    TRIX)
      dialog --inputbox "Set when loading this as part of the Audiotrix setup only ( 1=ENABLE, 0=DISABLE )" 9 60 $S_TRIX 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_TRIX=`cat $TEMPSCRIPT`
      fi
      ;;

    PAS2)
      dialog --inputbox "Set when loading this as part of the Pas2 setup only ( 1=ENABLE, 0=DISABLE )" 9 60 $S_PAS2 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_PAS2=`cat $TEMPSCRIPT`
      fi
      ;;

    SMG)
      dialog --inputbox "Set if you have a Logitech soundman games ( 1=ENABLE, 0=DISABLE )" 9 60 $S_SMG 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_SMG=`cat $TEMPSCRIPT`
      fi
      ;;

    ACER)
      dialog --inputbox "Set this to detect cards in some ACER notebooks ( 1=ENABLE, 0=DISABLE )" 9 60 $S_ACER 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_ACER=`cat $TEMPSCRIPT`
      fi
      ;;

    MWAVE)
      dialog --inputbox "Set if you are trying to use this driver with mwave (see on) ( 1=ENABLE, 0=DISABLE )" 9 60 $S_MWAVE 2> $TEMPSCRIPT
      if [ $? -eq 0 ]; then
        S_MWAVE=`cat $TEMPSCRIPT`
      fi
      ;;

      
    SAVE)
      > $FILECONFIG
      echo "S_IO=\"$S_IO\"" >> $FILECONFIG
      echo "S_IRQ=\"$S_IRQ\"" >> $FILECONFIG
      echo "S_DMA=\"$S_DMA\"" >> $FILECONFIG
      echo "S_DMA16=\"$S_DMA16\"" >> $FILECONFIG
      echo "S_MPU=\"$S_MPU\"" >> $FILECONFIG
      echo "S_MAD16=\"$S_MAD16\"" >> $FILECONFIG
      echo "S_TRIX=\"$S_TRIX\"" >> $FILECONFIG
      echo "S_PAS2=\"$S_PAS2\"" >> $FILECONFIG
      echo "S_SMG=\"$S_SMG\"" >> $FILECONFIG
      echo "S_ACER=\"$S_ACER\"" >> $FILECONFIG
      echo "S_MWAVE=\"$S_MWAVE\"" >> $FILECONFIG
      dialog --msgbox "\nLe modifiche sono state salvate." 7 40
      exit
      ;;
      
    REMOVE)
      rm -f $FILECONFIG
      dialog --msgbox "\nIl file di configurazione e' stato rimosso." 7 50
      exit
      ;;
  esac

done
