#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Bad Penguin - Sound configuration utility
# 1.0.0 by agx@linux.it 

TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT=$TEMPDIR/tempscript.$$
trap 'rm -f $TEMPSCRIPT ; exit $USCITA' 0


# SoundBlaster
I_SB="Sound Blaster or compatible"
F_SB="/etc/sysconfig/$PROFILE/soundblaster.soundcard"

# OPL3
I_OPL3="OPL3 driver for synth music"
F_OPL3="/etc/sysconfig/$PROFILE/opl3.soundcard"


FILEMODULE="/etc/sysconfig/$PROFILE/sound.module"
FILENOMODULE="/etc/sysconfig/$PROFILE/remove-soundmodule"
cd /usr/local/lib/agx-soundconfig/
while [ 0 ]; do

  # Check configurations
  S_SB="$I_SB"
  [ -f $F_SB   ] && S_SB="$S_SB (configured)"
  S_OPL3="$I_OPL3"
  [ -f $F_OPL3 ] && S_OPL3="$S_OPL3 (configured)"

  # Show Menu
  dialog --title "Sound System Configuration" --menu "Choose a sound card" 19 59 12 \
    "SB"     "$S_SB" \
    "OPL3"   "$S_OPL3" \
    " "      "-----------------------------" \
    "SAVE"   "Save and apply the changes" \
    "REMOVE" "Remove sound modules from memory" \
    "STATS"  "See configured device properties" \
    "TEST"   "Perform a sound test (first save !)" \
    2> $TEMPSCRIPT
  REPLY=$?
  if [ $REPLY -ne 0 ]; then
    exit
  fi
  CHOICE=`cat $TEMPSCRIPT`

  case "$CHOICE" in

    SB)
      edit-soundblaster.sh
      ;;

    OPL3)
      edit-opl3.sh
      ;;

# ==============================================================

    SAVE)
      clear

      if [ -f $FILENOMODULE ]; then
        echoc GREEN "Removing previous modules"
        sh $FILENOMODULE
	REPLY=$?
	if [ $REPLY -ne 0 ]; then
	  echoc RED "Script return code is $REPLY"
	  read x
	fi
      fi
 
      echoc GREEN "Saving new settings"
      #===== Main Module ====
      echo "#!/bin/sh" > $FILEMODULE
      echo "modprobe sound" >> $FILEMODULE

      
      # SoundBlaster
      if [ -f $F_SB ]; then
        echo -e "\n#Load SoundBlaster Driver " >> $FILEMODULE
        echo "insmod uart401 " >> $FILEMODULE
        echo -n "insmod sb " >> $FILEMODULE
	. $F_SB
        [ ! "$S_IO" = "" ]    && echo -n " io=$S_IO " >> $FILEMODULE
        [ ! "$S_IRQ" = "" ]   && echo -n " irq=$S_IRQ " >> $FILEMODULE
        [ ! "$S_DMA" = "" ]   && echo -n " dma=$S_DMA " >> $FILEMODULE
        [ ! "$S_DMA16" = "" ] && echo -n " dma16=$S_DMA16 " >> $FILEMODULE
        [ ! "$S_MPU" = "" ]   && echo -n " mpu_io=$S_MPU " >> $FILEMODULE
        [ "$S_MAD16" = "1" ]  && echo -n " mad16=1 " >> $FILEMODULE
        [ "$S_TRIX" = "1" ]   && echo -n " trix=1 " >> $FILEMODULE
        [ "$S_PAS2" = "1" ]   && echo -n " pas2=1 " >> $FILEMODULE
        [ "$S_SMG" = "1" ]    && echo -n " sm_games=1 " >> $FILEMODULE
        [ "$S_ACER" = "1" ]   && echo -n " acer=1 " >> $FILEMODULE	
        [ "$S_MWAVE" = "1" ]  && echo -n " mwave_bug=1 " >> $FILEMODULE
        echo -e "\n" >> $FILEMODULE
      fi

      if [ -f $F_OPL3 ]; then
        echo -e "\n#Load OPL3 Driver " >> $FILEMODULE
        echo -n "insmod opl3 " >> $FILEMODULE
	. $F_OPL3
        [ ! "$S_IO" = "" ]    && echo -n " io=$S_IO " >> $FILEMODULE
        echo -e "\n" >> $FILEMODULE
      fi

      # ===== NO MODULES ====
      echo "#!/bin/sh" > $FILENOMODULE
      if [ -f $F_OPL3 ]; then
        echo "rmmod opl3" >> $FILENOMODULE
      fi
      if [ -f $F_SB ]; then
        echo "rmmod sb" >> $FILENOMODULE
        echo "rmmod uart401" >> $FILENOMODULE
      fi
      echo "rmmod sound" >> $FILENOMODULE
      echo "rmmod soundlow" >> $FILENOMODULE
      echo "rmmod soundcore" >> $FILENOMODULE
        
            
      # --- LOAD NEW MODULES ---
      echo ; echoc GREEN "Loading sound system"
      sh $FILEMODULE
      REPLY=$?
      if [ $REPLY -ne 0 ]; then
        echoc RED "Script return code is $REPLY"
        read x
      fi      

      # --- Test sounds ---
      echo ; echoc GREEN "Testing the sound card ..."
      cat newmail.au > /dev/audio
      REPLY=$?
      if [ $REPLY -ne 0 ]; then
        echoc RED "Script return code is $REPLY"
        read x
      else
        echoc GREEN "Your sound card is working properly"
        sleep 1
      fi      
      ;;

# ===============================================================

    STATS)
      cat /proc/sound > $TEMPSCRIPT
      dialog --title "Sound device statistics" --textbox "$TEMPSCRIPT" 24 79
      ;;
      
    REMOVE)
      clear
      if [ -f $FILENOMODULE ]; then
        echoc GREEN "Removing previous modules"
        sh $FILENOMODULE
	REPLY=$?
	if [ $REPLY -ne 0 ]; then
	  echoc RED "Script return code is $REPLY"
	else
	  echoc GREEN "done."
	fi
	read x
      fi
      ;;
       
    TEST)
      clear
      echo ; echoc GREEN "Testing the sound card ..."
      cat newmail.au > /dev/audio
      REPLY=$?
      if [ $REPLY -ne 0 ]; then
        echoc RED "Script return code is $REPLY"
        read x
      else
        echoc GREEN "Your sound card is working properly"
      fi      
      ;;
      
  esac

done    